using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Microsoft.AnalysisServices;

namespace AmoDependencyCalculator
{
	class Program
	{
		static void Main(string[] args)
		{
			using (Server srv = new Server())
			{
				//connect to a server.
				srv.Connect("localhost");
				//Choose Foodmart 2005 database and Customer dimension.
				Database db = srv.Databases.GetByName("Foodmart 2005");
				Dimension dim = db.Dimensions.GetByName("Customer");
				//Create DependenciesCalculator. 
				DependenciesCalculator dependsCalculator = new DependenciesCalculator();
				//Analyze the objects affected by deletion of the "Customers" hiearchy.
				object[] objects = new object[] { dim.Hierarchies.GetByName("Customers") };
				Hashtable dependencies = dependsCalculator.GetDeleteDependents(db, objects, false);

				Console.WriteLine("Dependencies");
				//Iterate over all dependencies and print their description.
				foreach (IEnumerable dependencyList in dependencies.Values)
				{
					foreach (DependencyResult dependency in dependencyList)
					{
						Console.WriteLine(dependency.Description);
					}
				}
			}
		}
	}
}
