using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices;

namespace AmoDependentDeleteSample
{
	class Program
	{
		static void Main(string[] args)
		{
			using (Server srv = new Server())
			{
                //Connect to the server.
                srv.Connect("localhost");
                //Use the database Foodmart 2005.
				Database db = srv.Databases.GetByName("Foodmart 2005");
				//Iterate all the cubes
				Console.WriteLine("Before deletion");
				foreach (Cube cb in db.Cubes)
				{
					//Print the names of the hierarchies in the "Customer" cube dimension.
					CubeDimension dimCustomer = cb.Dimensions.FindByName("Customer");
					if (null!=dimCustomer)
					{
						foreach (CubeHierarchy hier in dimCustomer.Hierarchies)
						{
							Console.WriteLine(cb.ToString() + ": " + hier.ToString());
						}
					}
				}
				//Remove the hierarchy named "Customers" from the database dimension
                //named "Customer".
                Dimension dbDim = db.Dimensions.GetByName("Customer");
                Hierarchy dbHiear = dbDim.Hierarchies.GetByName("Customers");
                dbDim.Hierarchies.Remove(dbHiear);
                //Iterate all the cubes and make sure that no cube has the hierarchy
                //"Customers" in the dimension "Customers."
                Console.WriteLine("After deletion");
				foreach (Cube cb in db.Cubes)
				{
					CubeDimension dimCustomer = cb.Dimensions.FindByName("Customer");
					if (null!=dimCustomer)
					{
						foreach (CubeHierarchy hier in dimCustomer.Hierarchies)
						{
							Console.WriteLine(cb.ToString() + ": " + hier.ToString());
						}
					}
				}
			}
		}
	}
}
