using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices;

namespace AmoDisconnectedMode
{
	class Program
	{
		static void Main(string[] args)
		{
			string fileName = "..\\..\\amoserializedb.xml";
			//Call helper function that will create database, including the whole tree of its child objects, 
            //such as data source, cube, dimensions, and so on.
			Database db = CreateDatabase();
			//Create an XML writer that will be used to serialize the AMO objects into a file.
			System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(fileName, Encoding.UTF8);
			//Save the definitions of the database and the tree of AMO objects into the file.
			Utils.Serialize(writer, db, false);
			writer.Close();

			// ...Do some operations

			//Create an XML text reader that will be used to deserialize the AMO objects
			System.Xml.XmlTextReader reader = new System.Xml.XmlTextReader(fileName);
			//Read the objects from the file and create a database object.
			Database newDatabase = (Database)Utils.Deserialize(reader, new Database());
			reader.Close();

			//Create server object and connect to the Analysis Server
			using (Server srv = new Server())
			{
				srv.Connect("localhost");
				//Add the newly created database to the database collection, if no database with the same ID already exists in the collection.
				if (!srv.Databases.Contains(db.ID))
				{
					srv.Databases.Add(db);
					db.Update();
				}
				else
					throw (new ApplicationException("Database " + db.ID + "already exists on the server"));
			}
		}
		//We are oversimplifiyng this method to make 
		static Database CreateDatabase()
		{
			Database database = new Database("New Database", "New Database");
			return database;
		}
	}
}
