using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices;

namespace AmoErrorHandling
{
	class Program
	{
		static void Main(string[] args)
		{
			Server server = null;
			try
			{
			//Open a connection to the server.
				server = new Server();
				server.Connect("localhost");
				//Do some AMO operations
			}
			catch (ConnectionException conException)
			{
				Console.WriteLine(conException.Message);
				//Show a dialog box requesting the server name from the user.
				//...
			}
			catch (OperationException operationException)
			{
				foreach (XmlaResult result in operationException.Results)
				{
					foreach (XmlaMessage message in result.Messages)
					{
							if (message is XmlaWarning)
							Console.WriteLine(message.Description, "warning");
						else
							Console.WriteLine(message.Description, "error");
					}
				}
			} 
			catch (ResponseFormatException ex)
			{
				throw;
			}
			catch (OutOfSyncException outOfSyncException)
			{
				throw;
			}
			finally
			{
				if (server.Connected)
					server.Disconnect();
			}
		}
	}
}
