using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.AnalysisServices;

namespace AmoScripter
{
	class Program
	{
		static void Main(string[] args)
		{
			ScriptDatabase();
			ScriptDatabaseAlter();
			ScriptBatch();
		}
		static void ScriptDatabase()
		{
			//Create a server object.
			using (Server srv = new Server())
			{
				string fileName = "..\\..\\scriptDB.xml";

				//Connect to the server.
				srv.Connect("localhost");
				Database db = srv.Databases.FindByName("Foodmart 2005");
				//Create the scripter object.
				Scripter scripter = new Scripter();
				//Create xmltext writer, which will be used to script the command into the file
				System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(fileName, Encoding.UTF8);
				//Create a scriptInfo object.
				ScriptInfo scriptInfo = new ScriptInfo(db, ScriptAction.AlterWithAllowCreate, ScriptOptions.Default, false);
				//Create an array of the scriptInfo objects. In this example, the array contains just one element.
				ScriptInfo[] scriptInfos = new ScriptInfo[] { scriptInfo };
				//create a scripter object.
				scripter.Script(scriptInfos, writer);
				//Close the XML writer.
				writer.Close();
			}
		}
		static void ScriptDatabaseAlter()
		{
			//Create a server object.
			using (Server srv = new Server())
			{
				//Connect to the server.
				srv.Connect("localhost");
				Database db = srv.Databases.FindByName("Foodmart 2005");
				Scripter scripter = new Scripter();
				string fileName = "..\\..\\scriptDBAlter.xml";
				//Create XMLtext writer, which will be used to script the command.
				System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(fileName, Encoding.UTF8);
				//Create an array of  major objects. In this example, the array contains just one element.
				MajorObject[] objects = new MajorObject[] { db };
				//Script Alter command.
				scripter.ScriptAlter(objects, writer, false);
				//Close the XML writer.
				writer.Close();
			}
		}
		static void ScriptBatch()
		{
			//Create a Server object.
			using (Server srv = new Server())
			{
				//Cconnect to the server.
				srv.Connect("localhost");
				Scripter scripter = new Scripter();
				string fileName = "..\\..\\scriptDBBatch.xml";
				//Create XMLtext writer, which will be used to script the command.
				System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(fileName, Encoding.UTF8);
				//Start a transactional batch.
				Scripter.WriteStartBatch(writer,true);
				foreach (Database db in srv.Databases)
				{
					//Script the processing of the database.
					Scripter.WriteProcess(writer, db, ProcessType.ProcessFull);
				}
				//End the batch.
				Scripter.WriteEndBatch(writer);
				//Close XML writer
				writer.Close();
			}
		}
	}
}
